<System.Runtime.InteropServices.ProgId("ACE.VisualBuild.SelectVersion")> Public Class SelectVersion
    Implements VisBuildSvr.ICustomAction

    Public Function BuildStep(ByVal Builder As VisBuildSvr.Builder, ByVal [step] As VisBuildSvr.IStep) As VisBuildSvr.StepStatusEnum Implements VisBuildSvr.ICustomAction.BuildStep

        Dim frmSelect As New frmVersionSelection

        Try
            frmSelect.DialogProperties.CurrentVersion = [step].ExpProperty(Builder, "CurrentVersion")
            frmSelect.DialogProperties.AppName = [step].ExpProperty(Builder, "AppName")
            frmSelect.DialogProperties.SelectionList = [step].ExpProperty(Builder, "SelectionString")

            frmSelect.DialogProperties.Level01.Name = [step].ExpProperty(Builder, "Level01Name")
            frmSelect.DialogProperties.Level01.CurrentVersion = [step].ExpProperty(Builder, "Level01CurrentVersion")
            frmSelect.DialogProperties.Level01.TimeDate = [step].ExpProperty(Builder, "Level01TimeDate")
            frmSelect.DialogProperties.Level01.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level01Show", 11))

            frmSelect.DialogProperties.Level02.Name = [step].ExpProperty(Builder, "Level02Name")
            frmSelect.DialogProperties.Level02.CurrentVersion = [step].ExpProperty(Builder, "Level02CurrentVersion")
            frmSelect.DialogProperties.Level02.TimeDate = [step].ExpProperty(Builder, "Level02TimeDate")
            frmSelect.DialogProperties.Level02.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level02Show", 11))

            frmSelect.DialogProperties.Level03.Name = [step].ExpProperty(Builder, "Level03Name")
            frmSelect.DialogProperties.Level03.CurrentVersion = [step].ExpProperty(Builder, "Level03CurrentVersion")
            frmSelect.DialogProperties.Level03.TimeDate = [step].ExpProperty(Builder, "Level03TimeDate")
            frmSelect.DialogProperties.Level03.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level03Show", 11))

            frmSelect.DialogProperties.Level04.Name = [step].ExpProperty(Builder, "Level04Name")
            frmSelect.DialogProperties.Level04.CurrentVersion = [step].ExpProperty(Builder, "Level04CurrentVersion")
            frmSelect.DialogProperties.Level04.TimeDate = [step].ExpProperty(Builder, "Level04TimeDate")
            frmSelect.DialogProperties.Level04.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level04Show", 11))

            frmSelect.DialogProperties.Level05.Name = [step].ExpProperty(Builder, "Level05Name")
            frmSelect.DialogProperties.Level05.CurrentVersion = [step].ExpProperty(Builder, "Level05CurrentVersion")
            frmSelect.DialogProperties.Level05.TimeDate = [step].ExpProperty(Builder, "Level05TimeDate")
            frmSelect.DialogProperties.Level05.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level05Show", 11))

            frmSelect.DialogProperties.Level06.Name = [step].ExpProperty(Builder, "Level06Name")
            frmSelect.DialogProperties.Level06.CurrentVersion = [step].ExpProperty(Builder, "Level06CurrentVersion")
            frmSelect.DialogProperties.Level06.TimeDate = [step].ExpProperty(Builder, "Level06TimeDate")
            frmSelect.DialogProperties.Level06.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level06Show", 11))

            frmSelect.DialogProperties.Level07.Name = [step].ExpProperty(Builder, "Level07Name")
            frmSelect.DialogProperties.Level07.CurrentVersion = [step].ExpProperty(Builder, "Level07CurrentVersion")
            frmSelect.DialogProperties.Level07.TimeDate = [step].ExpProperty(Builder, "Level07TimeDate")
            frmSelect.DialogProperties.Level07.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level07Show", 11))

            frmSelect.DialogProperties.Level08.Name = [step].ExpProperty(Builder, "Level08Name")
            frmSelect.DialogProperties.Level08.CurrentVersion = [step].ExpProperty(Builder, "Level08CurrentVersion")
            frmSelect.DialogProperties.Level08.TimeDate = [step].ExpProperty(Builder, "Level08TimeDate")
            frmSelect.DialogProperties.Level08.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level08Show", 11))

            frmSelect.DialogProperties.Level09.Name = [step].ExpProperty(Builder, "Level09Name")
            frmSelect.DialogProperties.Level09.CurrentVersion = [step].ExpProperty(Builder, "Level09CurrentVersion")
            frmSelect.DialogProperties.Level09.TimeDate = [step].ExpProperty(Builder, "Level09TimeDate")
            frmSelect.DialogProperties.Level09.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level09Show", 11))

            frmSelect.DialogProperties.Level10.Name = [step].ExpProperty(Builder, "Level10Name")
            frmSelect.DialogProperties.Level10.CurrentVersion = [step].ExpProperty(Builder, "Level10CurrentVersion")
            frmSelect.DialogProperties.Level10.TimeDate = [step].ExpProperty(Builder, "Level10TimeDate")
            frmSelect.DialogProperties.Level10.Show = Convert.ToBoolean([step].ExpProperty(Builder, "Level10Show", 11))

            frmSelect.ShowDialog()

            If frmSelect.DialogProperties.OKButtonWasPressed = True Then
                If frmSelect.DialogProperties.AllLevelsCompleted = True Then
                    Builder.LogMessage("All active* levels of testing are currently deployed to.  All build steps should be skipped automatically!", True)
                    Builder.LogMessage("* Active levels refer to the testing levels that are marked to be shown in this custom action.", True)
                End If
                Builder.App.Macros(VisBuildSvr.MacroTypeEnum.vbldMacroProject).Add("VSS_VERSION_TO_GET", frmSelect.DialogProperties.SelectedVersion)
                Builder.App.Macros(VisBuildSvr.MacroTypeEnum.vbldMacroProject).Add("VSS_VERSION_TIMEDATE", DateTime.Now.Hour & ":" & DateTime.Now.Minute & " " & DateTime.Now.Month & "/" & DateTime.Now.Day & "/" & DateTime.Now.Year)
                Builder.LogMessage("Version Selected: " & frmSelect.DialogProperties.SelectedVersion, True)
                BuildStep = VisBuildSvr.StepStatusEnum.vbldStepStatSucceeded
            Else
                Builder.LogMessage("User selected 'Cancel' from the 'Version Selection' dialoge", True)
                BuildStep = VisBuildSvr.StepStatusEnum.vbldStepStatAborted
            End If

        Catch e As Exception

            BuildStep = VisBuildSvr.StepStatusEnum.vbldStepStatFailed
            Builder.LogMessage(e.Message)

        Finally

            ' release our references to COM objects passed in
            System.Runtime.InteropServices.Marshal.ReleaseComObject(Builder)
            System.Runtime.InteropServices.Marshal.ReleaseComObject([step])

            frmSelect.Close()
            frmSelect.Dispose()

        End Try

    End Function

End Class

